
;*** definitions for automation: typedefs, structures, enums, interfaces  ***
;*** curr defined structures: 
;***	SAFEARRAYBOUND, SAFEARRAY, VARIANT, TYPEDESC
;***	ARRAYDESC, PARAMDESCEX, PARAMDESC, IDLDESC
;***	ELEMDESC, FUNCDESC, VARDESC, TLIBATTR, TYPEATTR
;***	DISPPARAMS, CUSTDATAITEM, CUSTDATA
;*** curr defined interfaces: 
;***	ICreateTypeInfo, ICreateTypeLib
;***	IDispatch, IEnumVARIANT
;***	ITypeInfo, ITypeInfo2
;***	ITypeLib, ITypeLib2
;***	IErrorInfo, ICreateErrorInfo, ISupportErrorInfo
;***	IErrorLog, IPropertyBag
;***	IRecordInfo

;*** simple types

VARIANT_BOOL    typedef word
BSTR            typedef	ptr word
VARTYPE         typedef	word
LCID            typedef	dword
HREFTYPE        typedef	dword
ifndef PVOID
PVOID			typedef	ptr
endif
DISPID			typedef sdword
MEMBERID		typedef sdword
LPDISPID		typedef ptr DISPID
ifndef LPWSTR
LPWSTR			typedef ptr WORD
endif

FUNCKIND		typedef dword
INVOKEKIND		typedef dword
VARKIND			typedef dword
CALLCONV		typedef dword
SYSKIND			typedef dword
TYPEKIND		typedef	dword


;--- the language stuff is from WINNT.H

ifndef MAKELANGID
MAKELANGID macro p:req, s:req
	exitm <(s shl 10) or p>
	endm
endif

ifndef MAKELCID
MAKELCID macro lgid:req, srtid:req
	exitm <(srtid shl 16) or lgid>
	endm
endif

LANG_NEUTRAL            equ         00h
SUBLANG_NEUTRAL         equ         00h   
SUBLANG_DEFAULT         equ         01h   
SUBLANG_SYS_DEFAULT     equ         02h   
SORT_DEFAULT            equ         00h

LANG_SYSTEM_DEFAULT    equ MAKELANGID(LANG_NEUTRAL, SUBLANG_SYS_DEFAULT)
LANG_USER_DEFAULT      equ MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT)
LOCALE_SYSTEM_DEFAULT  equ MAKELCID(LANG_SYSTEM_DEFAULT, SORT_DEFAULT)



;---------- SAFEARRAY ----------------------------------

SAFEARRAYBOUND	struct dword
cElements   dword       ?
lLbound     sdword      ?
SAFEARRAYBOUND	ends

LPSAFEARRAYBOUND	typedef ptr SAFEARRAYBOUND

SAFEARRAY   struct dword
    cDims       word        ?
    fFeatures   word        ?
    cbElements  dword       ?
    cLocks      dword       ?
    pvData      PVOID       ?
    rgsabound   SAFEARRAYBOUND      1t DUP (<>)
SAFEARRAY ENDS

LPSAFEARRAY     typedef ptr SAFEARRAY

LPRECORDINFO	typedef ptr IRecordInfo

;--------- VARIANT ------------------------

VARIANT struct 
vt				VARTYPE			VT_EMPTY
wReserved1		WORD			0
wReserved2		WORD			0
wReserved3		WORD			0
Union
	lVal			SDWORD			?	; VT_I4
	bVal			BYTE			?	; VT_UI1
	iVal			SWORD			?	; VT_I2
	fltVal			REAL4			?	; VT_R4
	dblVal			REAL8			?	; VT_R8
	boolVal 		VARIANT_BOOL	?	; VT_BOOL
	scode			SCODE			?	; VT_ERROR
	cyVal			QWORD			?	; VT_CY
	date			QWORD			?	; VT_DATE
	bstrVal 		BSTR			?	; VT_BSTR
	punkVal 		PVOID			?	; VT_UNKNOWN
	pdispVal		PVOID			?	; VT_DISPATCH
	parray			PVOID			?	; VT_ARRAY
	pbVal			PVOID			?	; VT_BYREF|VT_UI1
	piVal			PVOID			?	; VT_BYREF|VT_I2
	plVal			PVOID			?	; VT_BYREF|VT_I4
	pfltVal 		PVOID			?	; VT_BYREF|VT_R4
	pdblVal 		PVOID			?	; VT_BYREF|VT_R8
	pboolVal		PVOID			?	; VT_BYREF|VT_BOOL
	pscode			PVOID			?	; VT_BYREF|VT_ERROR
	pcyVal			PVOID			?	; VT_BYREF|VT_CY
	pdate			PVOID			?	; VT_BYREF|VT_DATE
	pbstrVal		PVOID			?	; VT_BYREF|VT_BSTR
	ppunkVal		PVOID			?	; VT_BYREF|VT_UNKNOWN
	ppdispVal		PVOID			?	; VT_BYREF|VT_DISPATCH
	pparray 		PVOID			?	; VT_BYREF|VT_ARRAY
	pvarVal 		PVOID			?	; VT_BYREF|VT_VARIANT
	byref			PVOID			?	; Generic ByRef
	cVal			SBYTE			?	; VT_I1
	uiVal			WORD			?	; VT_UI2
	ulVal			DWORD			?	; VT_UI4
	intVal			SDWORD			?	; VT_int
	uintVal 		DWORD			?	; VT_uint
	pdecVal 		PVOID			?	; VT_BYREF|VT_DECIMAL
	pcVal			PVOID			?	; VT_BYREF|VT_I1
	puiVal			PVOID			?	; VT_BYREF|VT_UI2
	pulVal			PVOID			?	; VT_BYREF|VT_UI4
	pintVal 		PVOID			?	; VT_BYREF|VT_int
	puintVal		PVOID			?	; VT_BYREF|VT_uint
	STRUCT								; VT_RECORD
		pvRecord	PVOID ?
		pRecInfo	LPRECORDINFO ?
	ENDS
ENDS
VARIANT ENDS

LPVARIANT typedef ptr VARIANT

;---------------------------------------------

LPTYPEDESC	typedef ptr TYPEDESC
LPARRAYDESC	typedef	ptr ARRAYDESC

TYPEDESC	struct	dword
Union
lptdesc		LPTYPEDESC	?
lpadesc		LPARRAYDESC	?
hreftype	HREFTYPE	?
ends
vt			VARTYPE	?
TYPEDESC	ends

;---------------------------------------------

ARRAYDESC	struct	dword
tdescElem   TYPEDESC	<>
cDims       WORD		?
rgbounds    SAFEARRAYBOUND  1 dup (<>)
ARRAYDESC	ends


;---------------------------------------------

;--- this structure is possibly wrong, variant begins at offset 8

PARAMDESCEX  STRUCT DWORD
    cBytes			dword    ?
    varDefaultValue VARIANT  <>
PARAMDESCEX ENDS

LPPARAMDESCEX typedef ptr PARAMDESCEX

PARAMDESC       STRUCT DWORD
    pparamdescex    LPPARAMDESCEX ?
    wParamFlags     word          ?
PARAMDESC ENDS

PARAMFLAG_NONE	    equ  0
PARAMFLAG_FIN	    equ  1
PARAMFLAG_FOUT	    equ  2
PARAMFLAG_FLCID	    equ  4
PARAMFLAG_FRETVAL	equ  8
PARAMFLAG_FOPT	    equ 10h
PARAMFLAG_FHASDEFAULT   equ 20h
PARAMFLAG_FHASCUSTDATA  equ 40h


LPPARAMDESC     typedef ptr PARAMDESC

;---------------------------------------------

IDLDESC		struct  dword
dwReserved	dword	?
wIDLFlags	word	?
IDLDESC		ends

IDLFLAG_NONE	equ PARAMFLAG_NONE
IDLFLAG_FIN     equ PARAMFLAG_FIN
IDLFLAG_FOUT	equ PARAMFLAG_FOUT
IDLFLAG_FLCID	equ PARAMFLAG_FLCID
IDLFLAG_FRETVAL	equ PARAMFLAG_FRETVAL

LPIDLDESC	typedef	ptr IDLDESC

;---------------------------------------------

ELEMDESC	STRUCT	dword
    tdesc	TYPEDESC    <>
    Union
        idldesc		IDLDESC     <>
        paramdesc	PARAMDESC   <>
    ENDS
ELEMDESC ENDS

LPELEMDESC	typedef ptr ELEMDESC

;---------------------------------------------
;--- FUNCKIND enum

FUNC_VIRTUAL               EQU      0H
FUNC_PUREVIRTUAL           EQU      1H
FUNC_NONVIRTUAL            EQU      2H
FUNC_STATIC                EQU      3H
FUNC_DISPATCH              EQU      4H

;--- INVOKEKIND enum
INVOKE_FUNC                EQU      1H
INVOKE_PROPERTYGET         EQU      2H
INVOKE_PROPERTYPUT         EQU      4H
INVOKE_PROPERTYPUTREF      EQU      8H


;--- CALLCONV enum
CC_FASTCALL                 EQU    0H
CC_CDECL                    EQU    1H
CC_MSCPASCAL                EQU    2H
CC_MACPASCAL                EQU    3H
CC_STDCALL                  EQU    4H
CC_FPFASTCALL               EQU    5H
CC_SYSCALL                  EQU    6H
CC_MPWCDECL                 EQU    7H
CC_MPWPASCAL                EQU    8H
CC_MAX                      EQU    9H

CC_PASCAL                   EQU    2H

;--- FUNCFLAGS flags
FUNCFLAG_FRESTRICTED		EQU   01h
FUNCFLAG_FSOURCE			EQU   02h
FUNCFLAG_FBINDABLE			EQU   04h
FUNCFLAG_FREQUESTEDIT		EQU   08h
FUNCFLAG_FDISPLAYBIND		EQU   010h
FUNCFLAG_FDEFAULTBIND		EQU   020h
FUNCFLAG_FHIDDEN			EQU   040h
FUNCFLAG_FUSESGETLASTERROR	EQU   080h
FUNCFLAG_FDEFAULTCOLLELEM	EQU   0100h
FUNCFLAG_FUIDEFAULT			EQU   0200h
FUNCFLAG_FNONBROWSABLE		EQU   0400h
FUNCFLAG_FREPLACEABLE		EQU   0800h
FUNCFLAG_FIMMEDIATEBIND		EQU   01000h



FUNCDESC        STRUCT DWORD
    memid               DWORD       ?
    lprgscode           DWORD       ?
    lprgelemdescParam   LPELEMDESC  ?
    funckind            FUNCKIND    ?
    invkind             INVOKEKIND  ?
    callconv            CALLCONV    ?
    cParams             WORD        ?
    cParamsOpt          WORD        ?
    oVft                WORD        ?
    cScodes             WORD        ?
    elemdescFunc        ELEMDESC    <>
    wFuncFlags          WORD        ?
FUNCDESC ENDS

LPFUNCDESC      typedef ptr FUNCDESC

;---------------------------------------------
;--- VARKIND enum

VAR_PERINSTANCE EQU     0H
VAR_STATIC      EQU     1H
VAR_CONST       EQU     2H
VAR_DISPATCH    EQU     3H

;--- VARFLAGS flags
VARFLAG_FREADONLY			EQU 01h
VARFLAG_FSOURCE 			EQU 02h
VARFLAG_FBINDABLE			EQU 04h
VARFLAG_FREQUESTEDIT		EQU 08h
VARFLAG_FDISPLAYBIND		EQU 010h
VARFLAG_FDEFAULTBIND		EQU 020h
VARFLAG_FHIDDEN 			EQU 040h
VARFLAG_FRESTRICTED 		EQU 080h
VARFLAG_FDEFAULTCOLLELEM	EQU 0100h
VARFLAG_FUIDEFAULT			EQU 0200h
VARFLAG_FNONBROWSABLE		EQU 0400h
VARFLAG_FREPLACEABLE		EQU 0800h
VARFLAG_FIMMEDIATEBIND		EQU 01000h
 

VARDESC     STRUCT  DWORD
    memid       DWORD       ?
    lpstrSchema PVOID       ?
    Union
        oInst       DWORD       ?
        lpvarValue  LPVARIANT   ?
    ENDS
    elemdescVar ELEMDESC    <>
    wVarFlags   WORD        ?
                WORD        ?       ; align to dword
    varkind     VARKIND     ?
VARDESC     ENDS

LPVARDESC       typedef     ptr VARDESC

;---------------------------------------------


TLIBATTR        STRUCT    dword
guid            GUID        <>      
lcid            DWORD       ?       
syskind         SYSKIND     ?       
wMajorVerNum    WORD        ?       
wMinorVerNum    WORD        ?       
wibFlags        WORD        ?
TLIBATTR        ENDS

LPTLIBATTR      typedef ptr TLIBATTR

;---------------------------------------------

TKIND_ENUM			equ 	0
TKIND_RECORD		equ 	1
TKIND_MODULE		equ 	2
TKIND_INTERFACE 	equ 	3
TKIND_DISPATCH		equ 	4
TKIND_COCLASS		equ 	5
TKIND_ALIAS 		equ 	6
TKIND_UNION 		equ 	7
TKIND_MAX			equ 	8

TYPEFLAG_FAPPOBJECT 		EQU	0001H
TYPEFLAG_FCANCREATE 		EQU	0002H
TYPEFLAG_FLICENSED			EQU	0004H
TYPEFLAG_FPREDECLID 		EQU	0008H
TYPEFLAG_FHIDDEN			EQU	0010H
TYPEFLAG_FCONTROL			EQU	0020H
TYPEFLAG_FDUAL				EQU	0040H
TYPEFLAG_FNONEXTENSIBLE 	EQU	0080H
TYPEFLAG_FOLEAUTOMATION 	EQU	0100H
TYPEFLAG_FRESTRICTED		EQU	0200H
TYPEFLAG_FAGGREGATABLE		EQU	0400H
TYPEFLAG_FREPLACEABLE		EQU	0800H
TYPEFLAG_FDISPATCHABLE		EQU	1000H
TYPEFLAG_FREVERSEBIND		EQU	2000H

TYPEATTR    struct  dword
guid                GUID        <>
lcid                LCID        ?
dwReserved          dword       ?
memidConstructor    MEMBERID    ?
memidDestructor     MEMBERID    ?
lpstrSchema 		PVOID		?
cbSizeInstance		dword		?
typekind			TYPEKIND	?
cFuncs				word		?
cVars				word		?
cImplTypes			word		?
cbSizeVft			word		?
cbAlignment 		word		?
wTypeFlags			word		?
wMajorVerNum		word		?
wMinorVerNum		word		?
tdescAlias			TYPEDESC	<>
idldescType 		IDLDESC 	<>
TYPEATTR ends

LPTYPEATTR      typedef ptr TYPEATTR


DISPPARAMS struct
rgvarg				LPVARIANT ?
rgdispidNamedArgs   LPDISPID ?
cArgs			    DWORD ?
cNamedArgs		    DWORD ?
DISPPARAMS ends

LPDISPPARAMS	typedef ptr DISPPARAMS


EXCEPINFO_fnDeferredFillInProto typedef proto stdcall :ptr EXCEPINFO
EXCEPINFO_fnDeferredFillIn typedef PTR EXCEPINFO_fnDeferredFillInProto

EXCEPINFO    STRUCT
    wCode           WORD        ?
    wReserved       WORD        ?
    bstrSource      BSTR        ?
    bstrDescription BSTR        ?
    bstrHelpFile    BSTR        ?
    dwHelpContext   DWORD       ?
    pvReserved      DWORD       ?
    pfnDeferredFillIn EXCEPINFO_fnDeferredFillIn ?
    scode           DWORD       ?
EXCEPINFO ENDS

LPEXCEPINFO     TYPEDEF     ptr EXCEPINFO


REGKIND_DEFAULT             EQU     0H
REGKIND_REGISTER            EQU     1H
REGKIND_NONE                EQU     2H

REGKIND         TYPEDEF     DWORD

DISPATCH_METHOD             EQU         1
DISPATCH_PROPERTYGET        EQU         2
DISPATCH_PROPERTYPUT        EQU         4
DISPATCH_PROPERTYPUTREF     EQU         8

SYS_WIN16	equ 0
SYS_WIN32	equ 1
SYS_MAC		equ 2

IMPLTYPEFLAG_FDEFAULT		equ 1
IMPLTYPEFLAG_FSOURCE		equ 2
IMPLTYPEFLAG_FRESTRICTED	equ 4
IMPLTYPEFLAG_FDEFAULTVTABLE	equ 8

DISPID_VALUE		equ	0
DISPID_UNKNOWN		equ	-1
DISPID_PROPERTYPUT	equ -3
DISPID_NEWENUM		equ -4
DISPID_EVALUATE		equ -5
DISPID_CONSTRUCTOR	equ -6
DISPID_DESTRUCTOR	equ -7
DISPID_COLLECT		equ -8

MEMBERID_NIL	equ DISPID_UNKNOWN

;-------------------------------------------------------------------

;*** definition ICreateTypeInfo

externdef stdcall IID_ICreateTypeInfo:IID

BEGIN_INTERFACE ICreateTypeInfo
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release
	STDMETHOD	SetGuid					,:ptr GUID
	STDMETHOD	SetTypeFlags			,:dword
	STDMETHOD	SetDocString			,:ptr
	STDMETHOD	SetHelpContext			,:dword
	STDMETHOD	SetVersion				,:dword,:dword
	STDMETHOD	AddRefTypeInfo			,:ptr TYPEINFO,:ptr HREFTYPE
	STDMETHOD	AddFuncDesc				,:dword,:ptr FUNCDESC
	STDMETHOD	AddImplType				,:dword,:HREFTYPE
	STDMETHOD	SetImplTypeFlags		,:dword,:sdword
	STDMETHOD	SetAlignment			,:dword
	STDMETHOD	SetSchema				,:ptr
	STDMETHOD	AddVarDesc				,:dword,:ptr VARDESC
	STDMETHOD	SetFuncAndParamNames	,:dword,:ptr,:dword
	STDMETHOD	SetVarName				,:dword,:ptr
	STDMETHOD	SetTypeDescAlias		,:ptr TYPEDESC
	STDMETHOD	DefineFuncAsDllEntry	,:dword,:ptr,:ptr
	STDMETHOD	SetFuncDocString		,:dword,:ptr
	STDMETHOD	SetVarDocString			,:dword,:ptr
	STDMETHOD	SetFuncHelpContext		,:dword,:dword
	STDMETHOD	SetVarHelpContext		,:dword,:dword
	STDMETHOD	SetMops					,:dword,:BSTR
	STDMETHOD	SetTypeIdldesc			,:ptr IDLDESC
	STDMETHOD	LayOut
END_INTERFACE

;-------------------------------------------------------------------

;*** definition ICreateTypeLib

externdef stdcall IID_ICreateTypeLib:IID

BEGIN_INTERFACE ICreateTypeLib
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release
	STDMETHOD	CreateTypeInfo			,:ptr,:TYPEKIND,:ptr ptr ICreateTypeInfo
	STDMETHOD	SetName					,:ptr
	STDMETHOD	SetVersion				,:dword,:dword
	STDMETHOD	SetGuid					,:ptr GUID
	STDMETHOD	SetDocString			,:ptr
	STDMETHOD	SetHelpFileName			,:ptr
	STDMETHOD	SetHelpContext			,:dword
	STDMETHOD	SetLcid					,:LCID
	STDMETHOD	SetLibFlags				,:dword
	STDMETHOD	SaveAllChanges
END_INTERFACE

;-------------------------------------------------------------------

;*** definition IDispatch

externdef stdcall IID_IDispatch:IID

BEGIN_INTERFACE IDispatch
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release
	STDMETHOD	GetTypeInfoCount		,:ptr DWORD
	STDMETHOD	GetTypeInfo				,:dword, :LCID, :ptr ptr ITypeInfo
	STDMETHOD	GetIDsOfNames			,:ptr IID,:ptr,:dword,:LCID,:ptr DISPID
	STDMETHOD	Invoke_					,:DISPID,:ptr IID,:LCID,:dword,:ptr DISPPARAMS,:ptr VARIANT,:ptr EXCEPINFO,:ptr DWORD
END_INTERFACE

LPDISPATCH typedef ptr IDispatch


;-------------------------------------------------------------------

;*** definition ITypeInfo

externdef stdcall IID_ITypeInfo:IID

BEGIN_INTERFACE ITypeInfo
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release
	STDMETHOD	GetTypeAttr				,:ptr ptr
	STDMETHOD	GetTypeComp             ,:ptr ptr
	STDMETHOD	GetFuncDesc             ,:dword,:ptr ptr
	STDMETHOD	GetVarDesc              ,:dword,:ptr ptr
	STDMETHOD	GetNames                ,:dword,:ptr,:dword,:ptr
	STDMETHOD	GetRefTypeOfImplType    ,:dword,:ptr
	STDMETHOD	GetImplTypeFlags        ,:dword,:ptr
	STDMETHOD	GetIDsOfNames           ,:ptr,:dword,:ptr
	STDMETHOD	Invoke_                 ,:ptr,:dword,:dword,:ptr,:ptr,:ptr,:ptr
	STDMETHOD	GetDocumentation        ,:dword,:ptr,:ptr,:ptr,:ptr
	STDMETHOD	GetDllEntry             ,:dword,:dword,:ptr,:ptr,:ptr
	STDMETHOD	GetRefTypeInfo          ,:dword,:ptr ptr
	STDMETHOD	AddressOfMember         ,:dword,:dword,:ptr
	STDMETHOD	CreateInstance          ,:ptr,:ptr,:ptr ptr
	STDMETHOD	GetMops                 ,:dword,:ptr
	STDMETHOD	GetContainingTypeLib    ,:ptr ptr,:ptr
	STDMETHOD	ReleaseTypeAttr         ,:ptr
	STDMETHOD	ReleaseFuncDesc         ,:ptr
	STDMETHOD	ReleaseVarDesc          ,:ptr
END_INTERFACE

LPTYPEINFO typedef ptr ITypeInfo

;-------------------------------------------------------------------

;*** definition ITypeInfo2

CUSTDATAITEM struct
guid		GUID <>
varValue	VARIANT <>
CUSTDATAITEM ends

LPCUSTDATAITEM typedef ptr CUSTDATAITEM

CUSTDATA struct
cCustData	DWORD ?
prgCustData	LPCUSTDATAITEM ?
CUSTDATA ends

LPCUSTDATA typedef ptr CUSTDATA

externdef stdcall IID_ITypeInfo2:IID

BEGIN_INTERFACE ITypeInfo2, ITypeInfo
	STDMETHOD	GetTypeKind				,:ptr TYPEKIND
	STDMETHOD	GetTypeFlags			,:ptr DWORD
	STDMETHOD	GetFuncIndexOfMemId		,:MEMBERID, :INVOKEKIND, :ptr DWORD
	STDMETHOD	GetVarIndexOfMemId		,:MEMBERID, :ptr DWORD
	STDMETHOD	GetCustData				,:REFGUID, :ptr VARIANT
	STDMETHOD	GetFuncCustData			,:DWORD, :REFGUID, :ptr VARIANT
	STDMETHOD	GetParamCustData		,:DWORD, :DWORD, :REFGUID, :ptr VARIANT
	STDMETHOD	GetVarCustData			,:DWORD, :REFGUID, :ptr VARIANT
	STDMETHOD	GetImplTypeCustData		,:DWORD, :REFGUID, :ptr VARIANT
	STDMETHOD	GetDocumentation2		,:MEMBERID, :LCID, :ptr BSTR, :ptr DWORD, :ptr BSTR
	STDMETHOD	GetAllCustData			,:ptr CUSTDATA
	STDMETHOD	GetAllFuncCustData		,:DWORD, :ptr CUSTDATA
	STDMETHOD	GetAllParamCustData		,:DWORD, :DWORD, :ptr CUSTDATA
	STDMETHOD	GetAllVarCustData		,:DWORD, :ptr CUSTDATA
	STDMETHOD	GetAllImplTypeCustData	,:DWORD, :ptr CUSTDATA
END_INTERFACE

LPTYPEINFO2 typedef ptr ITypeInfo2

;-------------------------------------------------------------------

;*** definition ITypeLib

externdef stdcall IID_ITypeLib:IID

BEGIN_INTERFACE ITypeLib, IUnknown
	STDMETHOD	GetTypeInfoCount		
	STDMETHOD	GetTypeInfo				,:DWORD,:ptr ptr ITypeInfo
	STDMETHOD	GetTypeInfoType			,:DWORD,:ptr
	STDMETHOD	GetTypeInfoOfGuid		,:ptr GUID,:ptr ptr
	STDMETHOD	GetLibAttr 				,:ptr ptr
	STDMETHOD	GetTypeComp				,:ptr ptr
	STDMETHOD	GetDocumentation		,:DWORD,:ptr,:ptr,:ptr,:ptr
	STDMETHOD	IsName 					,:ptr,:DWORD,:DWORD
	STDMETHOD	FindName				,:ptr,:DWORD,:ptr ptr,:ptr,:ptr
	STDMETHOD	ReleaseTLibAttr			,:ptr
END_INTERFACE

LPTYPELIB typedef ptr ITypeLib

;-------------------------------------------------------------------

;*** definition ITypeLib2

externdef stdcall IID_ITypeLib2:IID

BEGIN_INTERFACE ITypeLib2, ITypeLib
	STDMETHOD	GetCustData				,:REFGUID, :ptr VARIANT
	STDMETHOD	GetLibStatistics		,pcUniqueNames:ptr DWORD, pcchUniqueNames:ptr DWORD
	STDMETHOD	GetDocumentation2		,index:DWORD, lcid:LCID, pbstrHelpString:ptr BSTR, pdwHelpStringContext:ptr DWORD, pbstrHelpStringDll:ptr BSTR
	STDMETHOD	GetAllCustData			,pCustData:ptr CUSTDATA
END_INTERFACE

LPTYPELIB2 typedef ptr ITypeLib2

;-------------------------------------------------------------------

;*** definition ISupportErrorInfo

externdef stdcall IID_ISupportErrorInfo:IID

BEGIN_INTERFACE ISupportErrorInfo
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release

	STDMETHOD	InterfaceSupportsErrorInfo	,:ptr IID
END_INTERFACE

LPSUPPORTERRORINFO typedef ptr ISupportErrorInfo

;-------------------------------------------------------------------

;*** definition IEnumVARIANT

externdef stdcall IID_IEnumVARIANT:IID

LPENUMVARIANT typedef ptr IEnumVARIANT

BEGIN_INTERFACE IEnumVARIANT
	STDMETHOD	QueryInterface			,:ptr IID,:ptr ptr
	STDMETHOD	AddRef
	STDMETHOD	Release
	STDMETHOD	Next					,:DWORD, :ptr VARIANT, :ptr DWORD
	STDMETHOD	Skip					,:DWORD
	STDMETHOD	Reset
	STDMETHOD	Clone					,:ptr LPENUMVARIANT
END_INTERFACE

;-------------------------------------------------------------------

;*** definition ICreateErrorInfo

externdef stdcall IID_ICreateErrorInfo:IID

BEGIN_INTERFACE ICreateErrorInfo, IUnknown
	STDMETHOD	SetGUID			,:ptr IID
	STDMETHOD	SetSource		,:ptr WORD
	STDMETHOD	SetDescription	,:ptr WORD
	STDMETHOD	SetHelpFile		,:ptr WORD
	STDMETHOD	SetHelpContext	,:DWORD
END_INTERFACE

LPCREATEERRORINFO typedef ptr ICreateErrorInfo

;-------------------------------------------------------------------

;*** definition IErrorInfo

externdef stdcall IID_IErrorInfo:IID

BEGIN_INTERFACE IErrorInfo, IUnknown
	STDMETHOD	GetGUID			,:ptr IID
	STDMETHOD	GetSource		,:ptr BSTR
	STDMETHOD	GetDescription	,:ptr BSTR
	STDMETHOD	GetHelpFile		,:ptr BSTR
	STDMETHOD	GetHelpContext	,:ptr DWORD
END_INTERFACE

LPERRORINFO typedef ptr IErrorInfo

;-------------------------------------------------------------------

;*** definition IErrorLog

externdef stdcall IID_IErrorLog:IID

BEGIN_INTERFACE IErrorLog, IUnknown
	STDMETHOD	AddError	,pszPropName:ptr WORD, pExcepInfo:ptr EXCEPINFO
END_INTERFACE

LPERRORLOG typedef ptr IErrorLog

;-------------------------------------------------------------------

;*** definition IPropertyBag

externdef stdcall IID_IPropertyBag:IID

BEGIN_INTERFACE IPropertyBag, IUnknown
	STDMETHOD	Read		,pszPropName:ptr WORD, pVar:ptr VARIANT, pErrorLog:ptr IErrorLog
	STDMETHOD	Write		,pszPropName:ptr WORD, pVar:ptr VARIANT
END_INTERFACE

LPPROPERTYBAG typedef ptr IPropertyBag

;-------------------------------------------------------------------

;*** definition IRecordInfo

externdef stdcall IID_IRecordInfo:IID

BEGIN_INTERFACE IRecordInfo, IUnknown
	STDMETHOD	RecordInit		,pvNew:PVOID
	STDMETHOD	RecordClear		,pvExisting:PVOID
	STDMETHOD	RecordCopy		,pvExisting:PVOID, pvNew:PVOID
	STDMETHOD	GetGuid			,pguid:ptr GUID
	STDMETHOD	GetName			,pbstrName:ptr BSTR
	STDMETHOD	GetSize			,pcbSize:ptr DWORD
	STDMETHOD	GetTypeInfo		,ppTypeInfo:ptr ptr ITypeInfo
	STDMETHOD	GetField		,pvData:PVOID, szFieldName:LPOLESTR, pvarField:ptr VARIANT
	STDMETHOD	GetFieldNoCopy	,pvData:PVOID, szFieldName:LPOLESTR, pvarField:ptr VARIANT, ppvDataCArray:ptr PVOID
	STDMETHOD	PutField		,wFlags:DWORD, pvData:PVOID, szFieldName:LPOLESTR, pvarField:ptr VARIANT
	STDMETHOD	PutFieldNoCopy	,wFlags:DWORD, pvData:PVOID, szFieldName:LPOLESTR, pvarField:ptr VARIANT
	STDMETHOD	GetFieldNames	,pcNames:ptr DWORD, rgBstrNames:ptr BSTR
	STDMETHOD	IsMatchingType	,pRecordInfo:ptr IRecordInfo
	STDMETHOD	RecordCreate
	STDMETHOD	RecordCreateCopy,pvSource:PVOID, ppvDest:ptr PVOID
	STDMETHOD	RecordDestroy	,pvRecord:ptr PVOID
END_INTERFACE

LPRECORDINFO typedef ptr IRecordInfo
