
;--- base definitions for COM

COINIT_APARTMENTTHREADED	equ 02h
COINIT_MULTITHREADED		equ 00h
COINIT_DISABLE_OLE1DDE		equ 04h
COINIT_SPEED_OVER_MEMORY	equ 08h

externdef GUID_NULL:GUID
IID_NULL    textequ <GUID_NULL>

BSTR            typedef	ptr word
REFGUID         typedef ptr GUID
REFIID          typedef ptr IID
ifndef HRESULT
HRESULT			typedef DWORD
endif

ifndef FACILITY_CONTROL
FACILITY_CONTROL equ 0ah
endif

;;-------------------------------------------------------------------
;;--- macros inside:
;;--- SUCCEEDED()			: query successful result of a COM call
;;--- FAILED()				: query unsuccessful result of a COM call
;;--- MAKE_HRESULT()		: assembles a HRESULT

;;--- BEGIN_INTERFACE		: starts definition of a vtable interface
;;--- END_INTERFACE			: ends definition of a vtable interface
;;--- STDMETHOD				: defines an entry in a vtable interface
;;--- DISPMETHOD (dummy)	: defines entry in a dispatch interface
;;--- vf()					: calls method of vtable interface
;;-------------------------------------------------------------------

SUCCEEDED macro x
ifb <x>
	exitm <!SIGN?>
else
 	test x,x
	exitm <!SIGN?>
endif
	endm

FAILED macro x
ifb <x>
	exitm <SIGN?>
else
 	test x,x
	exitm <SIGN?>
endif
	endm

MAKE_HRESULT	macro sev,fac,code
	exitm <(sev shl 31) or (fac shl 16) or (code)>
	endm


;------------------------------------------------------
; BEGIN_INTERFACE starts an interface definition
; Used in COMView generated includes. sets equate ??Interface. 
;------------------------------------------------------
; defines textequates ??Interface, ??Function, so dont use these names
;------------------------------------------------------

BEGIN_INTERFACE macro name, inheritedfrom
??Interface equ <name>
&name&Vtbl	struct
ifnb <inheritedfrom>
	inheritedfrom&Vtbl <>
endif
		endm


;------------------------------------------------------
; END_INTERFACE finishes current interface definition
; Used in includes. clears equate ??Interface
;------------------------------------------------------

END_INTERFACE macro

%??Interface&Vtbl	ends
%p&??Interface&Vtbl	typedef ptr ??Interface&Vtbl

??Interface	struct
%lpVtbl p&??Interface&Vtbl ?
??Interface	ends

??Interface equ <>
		endm


;------------------------------------------------------
; STDMETHOD macro defines an entry in a vtable interface
; Used in includes generated by COMView. 
;------------------------------------------------------

STDMETHOD	macro name:req,arguments:VARARG

ifnb <arguments>
%proto&??Interface&_&name& typedef proto :ptr,&arguments
else
%proto&??Interface&_&name& typedef proto :ptr
endif

%p&??Interface&_&name& typedef ptr proto&??Interface&_&name

;;??Function	catstr <name>,<	p>,??Interface,<_>,<name>,< ?>
;;??Function
%	name	p&??Interface&_&name ?
		endm

;------------------------------------------------------
; DISPMETHOD macro does nothing any longer but COMView
; will still generate such code so do not delete it
;------------------------------------------------------

DISPMETHOD macro name:REQ, arguments:VARARG
if 0
ifnb <arguments>
%??Interface&_&name& proto :LPDISPATCH,&arguments
else
%??Interface&_&name& proto :LPDISPATCH
endif
endif
	endm


;-------------------------------------------------------------------
; vf() is used to call a method/property from a vtable interface
;-------------------------------------------------------------------
; usage: "invoke vf(pInterface,Interface,Function)<,arguments>"
; edx is used, so it cannot be used as a parameter!
; and global textequate ??thispointer is used, so dont use it
;-------------------------------------------------------------------

vf macro this:req,ifvt,func:req
;;local ??thispointer
??thispointer	equ <edx>
ifidni <this>,<edx>
??thispointer equ <ecx>
endif
	mov ??thispointer,this
	mov ??thispointer,[??thispointer].ifvt.lpVtbl
	exitm <[??thispointer].&ifvt&Vtbl.&func&,this>
	endm

;;--- end of file
